/* 
 * Berkeley Lab Checkpoint/Restart (BLCR) for Linux is Copyright (c)
 * 2003, The Regents of the University of California, through Lawrence
 * Berkeley National Laboratory (subject to receipt of any required
 * approvals from the U.S. Dept. of Energy).  All rights reserved.
 *
 * Portions may be copyrighted by others, as may be noted in specific
 * copyright notices within specific files.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: cr_arch.h,v 1.1 2004/10/12 20:35:56 phargrov Exp $
 */

#ifndef _CR_ARCH_H
#define _CR_ARCH_H	1

// Catch-all file for misc. arch-specific bits

// Like a call to ioctl(), but w/o mucking errno which may not yet be available.
#include <asm/unistd.h>
static inline int __attribute__ ((unused))
cri_ioctl(int fd, int cmd, void *arg, int *errno_p)
{
    long res;
#ifdef PIC
    __asm__ volatile (
	"\tpushl %%ebx\n"
	"\tmovl %2,%%ebx\n"
	"\tint $0x80\n"
	"\tpopl %%ebx"
        : "=a" (res)
        : "0" (__NR_ioctl), "r" ((long)(fd)),"c" ((long)(cmd)), "d" ((long)(arg)));
#else
    __asm__ volatile (
	"\tint $0x80\n"
        : "=a" (res)
        : "0" (__NR_ioctl), "b" ((long)(fd)),"c" ((long)(cmd)), "d" ((long)(arg)));
#endif

    if ((unsigned long)res >= (unsigned long)(-4096)) {
	*errno_p = -res;
	res = -1;
    }

    return (int)res;
}

#endif
